--[[enterprise-e-v2-Lua Upgrade]]--

function InitGame(levelTime, randomSeed, restart)  
	game.Print("Initializing Lua Map Upgrade ..."); 
	game.Print("-map_restart ...");
	game.Print("--workaround-setup ...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "target_levelchange");
			ent:SetKeyValue("targetname", "map_restart");
			ent:SetKeyValue("target", "enterprise-e-v2");
			entity.CallSpawn(ent); 
	game.Print("--trigger-setup ...");
		if restart == 1 then 
			game.ClientPrint(-1, "Please don't use map_restart, use map or devmap instead.");
			game.Print("Please don't use map_restart, use map or devmap instead.");
			ent = entity.Find("map_restart")
			entity.Use(ent)
		end
	game.Print("-Adding Transporter with UI ...");
		game.Print("--redirecting usable ...");
			ent = entity.FindBModel(221);
			ent:SetKeyValue("target", "tr_ui");
			entity.CallSpawn(ent);
		game.Print("--setting up trigger ...");
			ent = entity.Spawn();
			mover.SetPosition(ent, -3768, 3316, 312);
			ent.SetupTrigger(ent, 208, 208, 80);
			ent:SetKeyValue("classname", "trigger_transporter");
			ent:SetKeyValue("wait", "5");
			ent:SetKeyValue("targetname", "tr_trigger");
			entity.CallSpawn(ent);
		game.Print("--setting up UI ...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "ui_transporter");
			ent:SetKeyValue("targetname", "tr_ui");
			ent:SetKeyValue("target", "tr_trigger");
			entity.CallSpawn(ent);
	game.Print("-Turbolift Setup ...");
		game.Print("--Deck 1 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(90);
				ent:SetKeyValue("target", "tld1");
				ent = entity.FindBModel(86);
				ent:SetKeyValue("target", "tld1");
				ent = entity.FindBModel(87);
				ent:SetKeyValue("target", "tld1");
				ent = entity.FindBModel(167);
				ent:SetKeyValue("target", "tld1");
				ent = entity.FindBModel(88);
				ent:SetKeyValue("target", "tld1");
				ent = entity.FindBModel(89);
				ent:SetKeyValue("target", "tld1");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(7);
				ent:SetKeyValue("targetname", "tld1doors");
				ent = entity.FindBModel(8);
				ent:SetKeyValue("targetname", "tld1doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 144, 100, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld1");
				ent:SetKeyValue("target", "tld1doors");
				ent:SetKeyValue("health", "1");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -2976, 8028, 887);
				mover.SetAngles(ent, 0, 270, 0);
		game.Print("--Deck 2 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(117);
				ent:SetKeyValue("target", "tld2");
				ent = entity.FindBModel(118);
				ent:SetKeyValue("target", "tld2");
				ent = entity.FindBModel(116);
				ent:SetKeyValue("target", "tld2");
				ent = entity.FindBModel(115);
				ent:SetKeyValue("target", "tld2");
				ent = entity.FindBModel(169);
				ent:SetKeyValue("target", "tld2");
				ent = entity.FindBModel(119);
				ent:SetKeyValue("target", "tld2");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(73);
				ent:SetKeyValue("targetname", "tld2doors");
				ent = entity.FindBModel(74);
				ent:SetKeyValue("targetname", "tld2doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 144, 100, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld2");
				ent:SetKeyValue("target", "tld2doors");
				ent:SetKeyValue("health", "2");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -7486, 3354, 272);
				mover.SetAngles(ent, 0, 270, 0);
		game.Print("--Deck 3 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(91);
				ent:SetKeyValue("target", "tld3");
				ent = entity.FindBModel(92);
				ent:SetKeyValue("target", "tld3");
				ent = entity.FindBModel(93);
				ent:SetKeyValue("target", "tld3");
				ent = entity.FindBModel(94);
				ent:SetKeyValue("target", "tld3");
				ent = entity.FindBModel(95);
				ent:SetKeyValue("target", "tld3");
				ent = entity.FindBModel(168);
				ent:SetKeyValue("target", "tld3");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(40);
				ent:SetKeyValue("targetname", "tld3doors");
				ent = entity.FindBModel(41);
				ent:SetKeyValue("targetname", "tld3doors");				
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 100, 144, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld3");
				ent:SetKeyValue("target", "tld3doors");
				ent:SetKeyValue("health", "3");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -3964, 3882, 272);
				mover.SetAngles(ent, 0, 180, 0);
		game.Print("--Deck 7 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(101);
				ent:SetKeyValue("target", "tld7");
				ent = entity.FindBModel(102);
				ent:SetKeyValue("target", "tld7");
				ent = entity.FindBModel(103);
				ent:SetKeyValue("target", "tld7");
				ent = entity.FindBModel(104);
				ent:SetKeyValue("target", "tld7");
				ent = entity.FindBModel(105);
				ent:SetKeyValue("target", "tld7");
				ent = entity.FindBModel(171);
				ent:SetKeyValue("target", "tld7");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(77);
				ent:SetKeyValue("targetname", "tld7doors");
				ent = entity.FindBModel(76);
				ent:SetKeyValue("targetname", "tld7doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 100, 144, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld7");
				ent:SetKeyValue("target", "tld7doors");
				ent:SetKeyValue("health", "7");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -13752, 4758, 272);
				mover.SetAngles(ent, 0, 180, 0);
		game.Print("--Deck 8 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(96);
				ent:SetKeyValue("target", "tld8");
				ent = entity.FindBModel(97);
				ent:SetKeyValue("target", "tld8");
				ent = entity.FindBModel(98);
				ent:SetKeyValue("target", "tld8");
				ent = entity.FindBModel(99);
				ent:SetKeyValue("target", "tld8");
				ent = entity.FindBModel(100);
				ent:SetKeyValue("target", "tld8");
				ent = entity.FindBModel(170);
				ent:SetKeyValue("target", "tld8");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(112);
				ent:SetKeyValue("targetname", "tld8doors");
				ent = entity.FindBModel(111);
				ent:SetKeyValue("targetname", "tld8doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 100, 144, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld8");
				ent:SetKeyValue("target", "tld8doors");
				ent:SetKeyValue("health", "8");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -11700, 2336, 272);
				mover.SetAngles(ent, 0, 0, 0);
		game.Print("--Deck 16 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(106);
				ent:SetKeyValue("target", "tld16");
				ent = entity.FindBModel(107);
				ent:SetKeyValue("target", "tld16");
				ent = entity.FindBModel(108);
				ent:SetKeyValue("target", "tld16");
				ent = entity.FindBModel(109);
				ent:SetKeyValue("target", "tld16");
				ent = entity.FindBModel(110);
				ent:SetKeyValue("target", "tld16");
				ent = entity.FindBModel(172);
				ent:SetKeyValue("target", "tld16");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(113);
				ent:SetKeyValue("targetname", "tld16doors");
				ent = entity.FindBModel(114);
				ent:SetKeyValue("targetname", "tld16doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 100, 144, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld16");
				ent:SetKeyValue("target", "tld16doors");
				ent:SetKeyValue("health", "16");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -14632, 2192, 272);
				mover.SetAngles(ent, 0, 0, 0);
		game.Print("--Deck 18 ...");
			game.Print("---redirecting usables ...");
				ent = entity.FindBModel(173);
				ent:SetKeyValue("target", "tld18");
				ent = entity.FindBModel(174);
				ent:SetKeyValue("target", "tld18");
				ent = entity.FindBModel(175);
				ent:SetKeyValue("target", "tld18");
				ent = entity.FindBModel(176);
				ent:SetKeyValue("target", "tld18");
				ent = entity.FindBModel(177);
				ent:SetKeyValue("target", "tld18");
				ent = entity.FindBModel(180);
				ent:SetKeyValue("target", "tld18");
			game.Print("---renaming doors ...");
				ent = entity.FindBModel(178);
				ent:SetKeyValue("targetname", "tld18doors");
				ent = entity.FindBModel(179);
				ent:SetKeyValue("targetname", "tld18doors");
			game.Print("---Adding turbolift ...");
				ent = entity.Spawn();
				ent.SetupTrigger(ent, 144, 100, 98);
				ent:SetKeyValue("classname", "target_turbolift");
				ent:SetKeyValue("targetname", "tld18");
				ent:SetKeyValue("target", "tld18doors");
				ent:SetKeyValue("health", "18");
				ent:SetKeyValue("wait", 3000);
				entity.CallSpawn(ent);
				mover.SetPosition(ent, -13609, 394, -207);
				mover.SetAngles(ent, 0, 90, 0);
	game.Print("-Setting up force fields...");
		game.Print("--Sickbay...");
			ent = entity.FindBModel(161);
			ent:SetKeyValue("classname", "func_forcefield");
			ent:SetKeyValue("targetname", "sick-ff");
			entity.CallSpawn(ent);
			ent = entity.FindBModel(157);
			ent:SetKeyValue("target", "sick-ff");
			entity.CallSpawn(ent);
		game.Print("--Brig...");
			game.Print("---Cell A...");
				ent = entity.FindBModel(144);
				ent:SetKeyValue("classname", "func_forcefield");
				ent:SetKeyValue("targetname", "cell-a-ff");
				entity.CallSpawn(ent);
				ent = entity.FindBModel(149);
				ent:SetKeyValue("target", "cell-a-ff");
				entity.CallSpawn(ent);
			game.Print("---Cell B...");
				ent = entity.FindBModel(145);
				ent:SetKeyValue("classname", "func_forcefield");
				ent:SetKeyValue("targetname", "cell-b-ff");
				entity.CallSpawn(ent);
				ent = entity.FindBModel(150);
				ent:SetKeyValue("target", "cell-b-ff");
				entity.CallSpawn(ent);
			game.Print("---Cell C...");
				ent = entity.FindBModel(146);
				ent:SetKeyValue("classname", "func_forcefield");
				ent:SetKeyValue("targetname", "cell-c-ff");
				entity.CallSpawn(ent);
				ent = entity.FindBModel(151);
				ent:SetKeyValue("target", "cell-c-ff");
				entity.CallSpawn(ent);
		game.Print("--Warpcore...");
			ent = entity.FindBModel(207);
			ent:SetKeyValue("classname", "func_forcefield");
			ent:SetKeyValue("targetname", "core-ff");
			entity.CallSpawn(ent);
			ent = entity.FindBModel(208);
			ent:SetKeyValue("target", "core-ff");
			entity.CallSpawn(ent);
	game.Print("-Upgrading Engineering-Lockdown...")
		game.Print("--removing Forcefields...");
			ent = entity.FindBModel(228);
			entity.Remove(ent)
		game.Print("--usable fit...");
			ent = entity.FindBModel(188);
			ent:SetKeyValue("spawnflags", "520");
			ent:SetKeyValue("wait", "20");
			entity.CallSpawn(ent);
		game.Print("--boolean setup...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "target_boolean");
			ent:SetKeyValue("swapname", "t314");
			ent:SetKeyValue("spawnflags", "2");
			ent:SetKeyValue("falsetarget", "eng-ld-open");
			ent:SetKeyValue("truetarget", "eng-ld-close");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -13656, 2200, 300);
		game.Print("--relay open setup...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "target_relay");
			ent:SetKeyValue("targetname", "eng-ld-open");
			ent:SetKeyValue("luaUse", "scriptengldopen");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -13656, 2216, 300);
		game.Print("--relay close setup...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "target_relay");
			ent:SetKeyValue("targetname", "eng-ld-close");
			ent:SetKeyValue("luaUse", "scriptengldclose");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -13656, 2216, 300);
	game.Print("-Adding weapon FX ...");
		game.Print("--target setup ...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "info_notnull");
			ent:SetKeyValue("targetname", "weapTrg");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -192, 7684, 800);
		game.Print("--usable setup ...");
			ent = entity.FindBModel(212);
			ent:SetKeyValue("target", "phaser-vfx");
			entity.CallSpawn(ent);
			ent = entity.FindBModel(213);
			ent:SetKeyValue("target", "torpedo-vfx");
			entity.CallSpawn(ent);		
		game.Print("--Phaser ...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "fx_phaser");
			ent:SetKeyValue("target", "weapTrg");
			ent:SetKeyValue("targetname", "phaser-vfx");
			ent:SetKeyValue("wait", "3");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -2336, 7648, 832);
		game.Print("--Torpedo ...");
			ent = entity.Spawn();
			ent:SetKeyValue("classname", "fx_torpedo");
			ent:SetKeyValue("target", "weapTrg");
			ent:SetKeyValue("wait", "1");
			ent:SetKeyValue("count", "500");
			ent:SetKeyValue("targetname", "torpedo-vfx");
			entity.CallSpawn(ent);
			mover.SetPosition(ent, -2336, 7648, 768); 
	game.Print("... done.");
end 

function scriptengldclose ( ent , other , activator )
	ent = entity.FindBModel(82);
	ent.Lock(ent);
	ent = entity.FindBModel(83);
	ent.Lock(ent);
	ent = entity.FindBModel(84);
	ent.Lock(ent);
	ent = entity.FindBModel(85);
	ent.Lock(ent);
end

function scriptengldopen ( ent , other , activator )
	ent = entity.FindBModel(82);
	ent.Unlock(ent);
	ent = entity.FindBModel(83);
	ent.Unlock(ent);
	ent = entity.FindBModel(84);
	ent.Unlock(ent);
	ent = entity.FindBModel(85);
	ent.Unlock(ent);
end
